"use strict";

const path = _safeRequire("path");

const getDirFiles = _safeRequire("jinghuan-helper/getDirFiles");

const loadFiles = _safeRequire("jinghuan-helper/loadFiles");

const fs = _safeRequire("fs");

const debug = _safeRequire("debug");

const log = debug(`JH:core/loader/sql[${process.pid}]`);

function load(appPath, modules) {
    const cache = {};
    modules.forEach(item => {
        cache[item] = {};
        const itemCache = loadFiles(path.join(appPath, item, 'sql'), ['sql']);
        for (const name in itemCache) {
            cache[item][name] = fs.readFileSync(itemCache[name], "utf-8");
        }
    });
    return cache;
};

module.exports = load;

function _safeRequire(obj) {
    if (typeof obj === 'string') {
        try {
            obj = require(obj);
        } catch (e) {
            console.error(e);
            obj = null;
        }
    }

    return obj && obj.__esModule && typeof obj.default !== "undefined" ? obj.default : obj;
}