'use strict';

const path = _safeRequire('path');

const debug = _safeRequire('debug');

const loadFiles = _safeRequire('jinghuan-helper/loadFiles');

const log = debug(`JH:core/loader/validate[${process.pid}]`);

function load(appPath, modules) {
    const cache = {};
    modules.forEach(item => {
        cache[item] = {};
        const itemCache = loadFiles(path.join(appPath, item, 'validate'), ['js', 'json'], true);
        for (const name in itemCache) {
            cache[item][name] = itemCache[name];
        }
    });
    return cache;
};

module.exports = load;

function _safeRequire(obj) {
    if (typeof obj === 'string') {
        try {
            obj = require(obj);
        } catch (e) {
            console.error(e);
            obj = null;
        }
    }

    return obj && obj.__esModule && typeof obj.default !== "undefined" ? obj.default : obj;
}