'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const parse = _safeRequire('../core/payload/index.js');

const parse_str = _safeRequire('locutus/php/strings/parse_str');

function MidPayload(opts = {}) {
    let parseBody = (() => {
        var _ref2 = _asyncToGenerator(function* (ctx, opts) {
            const methods = ['POST', 'PUT', 'DELETE', 'PATCH', 'LINK', 'UNLINK'];

            if (methods.every(function (method) {
                return ctx.method !== method;
            })) {
                return {};
            }
            if (ctx.request.is(textTypes)) {
                let temp = yield parse.text(ctx, opts.opts);
                try {
                    return { post: JSON.parse(temp) };
                } catch (e) {
                    let data = {};
                    parse_str(temp, data);
                    return { post: data };
                }
            } else if (ctx.request.is(xmlTypes)) {
                    return yield parse.xml(ctx, opts.opts);
                } else if (ctx.request.is(multipartTypes)) {
                    let temp = yield parse.multipart(ctx, opts.multipartOpts);
                    return temp;
                }

            return {};
        });

        return function parseBody(_x3, _x4) {
            return _ref2.apply(this, arguments);
        };
    })();

    const extendTypes = Object.assign({
        json: [],
        form: [],
        text: [],
        multipart: [],
        xml: []
    }, opts.extendTypes);

    const jsonTypes = [];

    const formTypes = [];

    const textTypes = ['text/plain', 'text/json', 'application/x-www-form-urlencoded', 'application/json'];

    const multipartTypes = ['multipart/form-data'];

    const xmlTypes = ['text/xml', 'application/xml'];

    return (() => {
        var _ref = _asyncToGenerator(function* (ctx, next) {
            if (ctx.request.body !== undefined) {
                return yield next();
            }

            let param = {};
            parse_str(ctx.querystring, param);
            ctx.request._query = param;

            let body = yield parseBody(ctx, {
                opts: {
                    limit: opts.limit,
                    encoding: opts.encoding
                },
                multipartOpts: {
                    keepExtensions: opts.keepExtensions,
                    uploadDir: opts.uploadDir,
                    encoding: opts.encoding,
                    hash: opts.hash,
                    multiples: opts.multiples
                }
            });
            ctx.request.body = body;
            return yield next();
        });

        return function (_x, _x2) {
            return _ref.apply(this, arguments);
        };
    })();
};

exports.default = MidPayload;

function _safeRequire(obj) {
    if (typeof obj === 'string') {
        try {
            obj = require(obj);
        } catch (e) {
            console.error(e);
            obj = null;
        }
    }

    return obj && obj.__esModule && typeof obj.default !== "undefined" ? obj.default : obj;
}